//'use strict';

Array.prototype.min = function(){
	return this.length > 0 ? this.reduce((a, b) => Math.min(a, b)) : undefined;
}
String.prototype.mark = function (v) {
	return v && v.length > 0 ? this.replace(new RegExp('(' + v + ')', 'ig'), '<mark>$1</mark>') : this;
}
Number.prototype.conv = function () {
	return (this > 1024 ? this > 1048576 ? (this/1048576).toFixed(1) + ' MB' : (this/1024).toFixed(1) + ' KB' : this + 'B');
}
Number.prototype.NET = function (iso = false) {
	return this.toString().length > 0 ? new Date((this - 62135596800)*1000).toISOString().replace(/^(\d+)-(\d+)-(\d+)(T00:00|T(\d+)(:\d+)).*$/, (iso ? '$1-$2-$3$4' : '$3.$2.$1 $5$6')).trim():this;
}
Number.prototype.fixed = function (v=2) {
	return this.toFixed(v).replace(/([0-9]+(\.[0-9]+[1-9])?)(\.?0+$)/,'$1');
}

class Tree { 
	constructor() {
		this.set = {/* limit: '',  total: '',*/ access: {}};					// параметры дерева
		this.func = function(){};
		this.box;
	}	
	async Read(param) {
		let resp;
		try {
			let response = await fetch('./api.php?api2&tree' + (param?param:''), {credentials: 'same-origin'});
			resp = await response.json();
			this.set = resp.set;
		}
		catch (err) {
			resp = {error: 'Data not received...'};
		}
		return resp;		
	}
	Create(tree) {
		function a(obj/* , limit */) {
			let li = '';
			let ul;
			for (let key in obj) {				
				if (!parseInt(key) && key != 0) continue;
				let expand = '';					
				//for (let k in obj[key]) 
				//	if (typeof obj[key][k] === 'object' || limit == obj[key].type) {
						expand = ' class = "expand"';
				//		break;														
				//	}
				//li += '<li><b' + expand + ' data-t='+obj[key].type + '></b><i data-id='+obj[key].id+'>' + obj[key].name + '</i>' + a(obj[key] , limit) + '</li>';
				li += '<li><b' + expand + '></b><i data-id='+obj[key].id+'>' + obj[key].name + '</i>' + a(obj[key]) + '</li>';
			}
			if (li) {
				ul = '<ul>' + li + '</ul>'
			}
			return ul || '';
			}
		return a(tree.tree/* , tree.set.limit */);
	}
	async View() {
		let resp = await this.Read()
		if(resp.error) Notifications(resp.error, 'error');
		this.box.querySelector('.tree').innerHTML = this.Create(resp);
		this.Action(); 
	}
	ViewAdd(DOM, tree) {
		let out = this.Create(tree);			
		DOM.parentElement.classList.remove('load');			
		if (Object.keys(tree.tree).length != 0) {
			//DOM.classList.add('expand', 'show')
			DOM.parentElement.innerHTML += out;
		} else DOM.classList.remove('expand', 'show');
	}
	async Action() { 
		let	tree = this.box.querySelector('.tree'),
			set = this.box.querySelector('.tree-set'),
			action = this.box.querySelector('.tree-action'),
			active = () => Array.from(this.box.querySelectorAll('.tree .active:not(.hide)'));
		if(set) set.onclick = () => {
			//let type = Array();
			set.classList.toggle('edit');
			tree.classList.toggle('edit');
			action.classList.toggle('hide');
			if (!tree.classList.contains('edit')) {
				(() => {
					let active = Array.from(this.box.querySelectorAll('.tree .active'));
					if (active.length > 1) active.forEach((v) => v.classList.remove('active'));
				})();
				Array.from(this.box.querySelectorAll('.tree input,.tree u,.tree .hide')).forEach((v) => {
					if (v.nodeName == 'I') {v.classList.remove('hide'); return;} // .hide
					if (v.nodeName == 'U' || v.nodeName == 'INPUT' && v.parentElement.querySelector('i')) {v.remove(); return;} // input (часть), u				
					this.DelBranch(v); // input (остатки)									
				});
			} else this.ReSelect();
		}
		if(action) action.onclick = async (e) => {
			if(e.target.classList.contains('hide')) return;
			let	parent = active().length != 0 ? active()[0].parentElement : this.box.querySelector('.tree'),
			expand = Array.from(parent.children).filter(v => v.nodeName == 'B')[0];
			if (e.target.classList.contains('a')) {	
				if (parent.classList.contains('load')) return;
				let id = active().length != 0 ? active()[0].dataset.id : -1,
					//placeholder = ' placeholder=' + (expand ? this.set.title[+ expand.dataset.t + 1] : this.set.title[0]),
					placeholder = '',
					html = '<li><b></b><input type="text" data-parent=' + id + ' data-action="a"' + placeholder + '><u class="save"></u><u class="exit"></u></li>';
				if (expand && !expand.classList.contains('show')) await this.Expand(expand);
				if (parent.querySelector('ul')) parent.querySelector('ul').insertAdjacentHTML('afterbegin', html);	
				else {
					parent.insertAdjacentHTML('beforeend', '<ul>' + html + '</ul>');
					if(expand) expand.classList = 'expand show';
				}					
				parent.querySelector('input').focus();				
			}
			if (e.target.classList.contains('e')) {
				active().forEach((v) => {
					let html = '<input type="text" value="' + v.innerText + '" data-id=' + v.dataset.id + ' data-action="e"><u class="save"></u><u class="exit"></u>';					
					v.insertAdjacentHTML('afterend', html);	
					v.classList.add('hide');
				})
				this.ReSelect();
			}
			if (e.target.classList.contains('d')) {
				Confirm('Delete selected items?',
					async () => {					
						let id = '',
							active = Array.from(this.box.querySelectorAll('.tree .active:not(.hide)'));
						active.forEach(v => {id += (id != '' ? ',' : '') + v.dataset.id; v.classList.add('hide', 'load');})
						this.ReSelect();						
						let resp = await this.Read('=' + id + '&d');
						if(resp.error || resp.log) Notifications(resp.error || resp.log, (resp.error ? 'error':''));
						active.forEach(v => {
							if(resp.granted && resp.granted.indexOf(+v.dataset.id) != -1)
								this.DelBranch(v);
							v.classList.remove('hide', 'load');
						})						
						this.ReSelect();
					}
				);
			}
		}
		tree.onclick = async function(e) {
			if (e.target.classList.contains('expand')) this.Expand(e.target);			
			if (e.target.nodeName == 'I' && !tree.classList.contains('edit')) {					
				if(this.box.querySelector('.tree .active'))
					this.box.querySelector('.tree .active').classList.remove('active');
				e.target.classList.add('active');					
				let out = {text:'', id: Array()},
					el = e.target;
				while ((el = el.parentElement) && !el.classList.contains('tree'))
					if (el.nodeName == 'LI'){
						out.text = el.querySelector('i').innerText + (out.text != '' ? ', ' : '') + out.text;
						out.id.unshift(el.querySelector('i').dataset.id);
					}				
				this.func(out.id, out.text);
			}
			if (e.target.nodeName == 'I' && tree.classList.contains('edit')) {					
				e.target.classList.toggle('active');					
				this.ReSelect(e.target);
			}			
			if (e.target.nodeName == 'U') {					
				let li = e.target.closest('li'),
					input = li.querySelector('input'),
					eExit = li => {
						Array.from(li.children).forEach(v => {if(v.nodeName == 'U' || v.nodeName == 'INPUT') v.remove();});
						li.querySelector('i').classList.remove('hide');	
						this.ReSelect();
				};
				if (li.classList.contains('load')) return;
				if (e.target.classList.contains('save') && input.dataset.action == 'a') {						
					li.classList.add('load');
					let resp = await this.Read('=' + input.dataset.parent + '&a=' + encodeURIComponent(input.value));
					if(resp.error) Notifications(resp.error, 'error');
					li.classList.remove('load');
					//if(resp.id) li.innerHTML = '<b data-t="' + resp.type + '"></b><i data-id="' + resp.id + '">' + resp.name + '</i>';
					if(resp.id) li.innerHTML = '<b></b><i data-id="' + resp.id + '">' + resp.name + '</i>';
				}
				if (e.target.classList.contains('exit') && input.dataset.action == 'a') {
					this.DelBranch(e.target);
				}
				if (e.target.classList.contains('save') && input.dataset.action == 'e') {
					li.classList.add('load');
					let resp = await this.Read('=' + input.dataset.id + '&e=' + encodeURIComponent(input.value));
					if(resp.error) Notifications(resp.error, 'error');
					li.classList.remove('load');
					if(resp.id) {
						li.querySelector('i').innerText = resp.name;
						eExit(li);
					}
				}
				if (e.target.classList.contains('exit') && input.dataset.action == 'e') eExit(li);
			}
		}.bind(this)
		this.box.onkeydown = e => {
			let focus = document.activeElement,
				list = [].filter.call(this.box.querySelectorAll('input'), v => v.tabIndex >= '0'),
				index = list.indexOf(focus),
				func = s => {s?focus.nextElementSibling.click():focus.nextElementSibling.nextElementSibling.click();return true};
			((e.keyCode === 13&&func(true)||e.keyCode===27&&func(false))&&(list[++index]||list[0]).focus());			
		}
	}
	async Expand(id) {
		if (id.classList.contains('expand')) id.classList.toggle('show');
		if (/* id.dataset.t == this.set.limit 
			&& */ !id.parentElement.querySelector('ul')) {
			id.parentElement.classList.add('load');
			let resp = await this.Read('=' + id.parentElement.querySelector('i').dataset.id);
			if(resp.error) Notifications(resp.error, 'error');
			this.ViewAdd(id, resp);
		}
	}
	async ExpandPath(id) {
		let arr = id.split(',');
		for (let i = 0; i < arr.length; i++) {
			let a = this.box.querySelector('[data-id="' + arr[i] + '"'),			
				expand = a ? a.parentElement.querySelector('.expand') : false;			
			if (a && (!arr[i+1] || arr[i+1] < 1)) { 
				a.parentElement.querySelector('i').classList.add('active');
				this.Offset();
			} else if (expand) {
				expand.classList.add('show');			
				//if (this.set.limit == i) {
					a.parentElement.classList.add('load');
					let tree = await this.Read('=' + arr[i]);
					if (tree.error) 
						return console.log(tree.error);
					this.ViewAdd(a, tree);
				//}
			}
		}		
	}
	ReSelect(target) {
		let /* type = Array() ,*/
			type = '',
			action = this.box.querySelector('.tree-action'),
			active = Array.from(this.box.querySelectorAll('.tree .active'));
		active.forEach(function(v) {					
			if (target &&
				target.closest('ul') != v.closest('ul')) v.classList.remove('active');
			//else if(!v.classList.contains('hide')) type.push( + v.parentElement.querySelector('[data-t]').dataset.t);	
			else if(!v.classList.contains('hide')) {
				let UpTree = v, count = 0;
				while((UpTree = UpTree.parentElement) && !UpTree.classList.contains('tree')) (UpTree.nodeName == 'UL' && count++);
				type = --count;	// сдвиг позиции до 0							
			};	
		});
		//type = type.min();
		console.log(type);
		active = Array.from(this.box.querySelectorAll('.tree .active:not(.hide)'));
		for (let key in this.set.access) {					
			let b = action.querySelector('.' + key);
			if (!b) continue;
			/* if (( !(key == 'a' && this.set.access[key] < 1) && type == undefined ) ||  
				(key != 'a' && this.set.access[key] > + type) ||
				(key == 'a' && (this.set.access[key] - 1 > + type || this.set.total <= + type)) ||
				(active.length > 1 && !(key == 'd' || key == 'e'))) b.classList.add('hide'); */
			/* if (!this.set.access[key] ||
				(active.length < 1 && !(key == 'a')) ||
				(active.length > 1 && !(key == 'd' || key == 'e'))) b.classList.add('hide'); */
			if (this.set.access[key] === false ||
				(key == 'a' && (this.set.access[key] - 1 > type || this.set.total <= type)) ||
				(active.length < 1 && !(key == 'a' && this.set.access[key] == 0)) ||
				(active.length > 1 && !(key == 'd' || key == 'e'))) b.classList.add('hide');
			else b.classList.remove('hide'); 
		} 
	}
	DelBranch(target) {
		let ul = target.closest('ul');
		if (Array.from(ul.children).filter(v => v.nodeName == 'LI').length > 1) target.parentElement.remove();
		else {
			let li = ul.closest('li');
			if (li) li.querySelector('b').classList = '';
			ul.remove();
		}
	}
	Offset() {
		let box = this.box.querySelector('.tree'),
			a = box.getBoundingClientRect().top,
			s = box.scrollTop,
			b = box.querySelector('.active').getBoundingClientRect().top;
		if(b > box.offsetHeight + a)
			animate({
			  duration: 400,
			  timing: (timeFraction) => Math.pow(timeFraction, 2),
			  draw: (progress) => box.scrollTop = s + (b - a - 100) * progress,
			});
	}
	/* boxing example for kassa */
	OldBox(title) {
		document.body.insertAdjacentHTML('afterbegin', '\
		<div class="fon">\
			<div class="TreePopup move">\
				<div class="title move-push">' + title + '<div class="pop-b"><b class="hand move-push"></b><b class="tree-set"></b><b class="close"></b></div></div>\
				<div class="tree-action hide">\
					<b class="a"></b><b class="e"></b><b class="d"></b>\
				</div>\
				<div class="tree"><div class="loadblock"></div></div>\
			</div>\
		</div>');
		this.box = document.querySelector('.fon');
		let box = this.box.querySelector('.tree');
		this.box.onclick = function(e) {
			if(e.target == this ||
				e.target.nodeName == 'I' && !box.classList.contains('edit') ||
				e.target.classList.contains('close')) {
				this.classList.add('close');
				this.addEventListener('transitionend', () => this.remove())
			}
		}
	}
}

class Stock { 
	constructor() {
		this.box;
		this.prg = false;
		this.his = {};
	}
	async Read(param) {
		let resp;
		try {
			let response = await fetch('./api.php?api2&stock' + (param?param:''), {credentials: 'same-origin'});
			resp = await response.json();
			this.set = resp.set;
			this.prg = false;
		}
		catch (err) {
			resp = {error: 'Data not received...'};
			this.prg = false;
		}
		return resp;		
	}
	async StockList({stock_id, stock_parent, measure = '', countable = 0, field_id, shortguid, out = {}}) {
		if (this.prg) return Notifications(LNG[796], 'error');
		this.prg = true;
		let resp = await this.Read('&position=' + stock_parent /* + '&id=' + id */),
			html = '',
			field = field_id.replace(/[^0-9]+/, ''),
			filter = v => ((countable == 0 && (a = v.match(/\d+(,|\.)?\d{0,5}/i))) || (a = v.match(/\d+/))) && a != null ? a[0] : '', // ДРОБИ
			sum = '',
			a, b;
			var Size;
			if (resp.error) return Notifications(resp.error, 'error');
			if (resp.stock) resp.stock.result.forEach(v => {
				if (v.linked_id[shortguid] != undefined && v.linked_id[shortguid][field] != undefined)
					v.balance = +(+v.balance + +(sum = v.linked_id[shortguid][field])).toFixed(5);
					
				// ### his история оффлайн изменений позиций склада
				if (this.his[v.id] == undefined) this.his[v.id] = {};			
				let k = 0;
				for (let key in this.his[v.id]) {					
					if (key != field && this.his[v.id][key]) k = +(k + +this.his[v.id][key]).toFixed(5);				
					if (key != field && v.linked_id[shortguid] && v.linked_id[shortguid][key])
						v.balance = +(+v.balance + +v.linked_id[shortguid][key]).toFixed(5); 
				}
				v.balance = +(+v.balance - +k).toFixed(5);
				// ### end his

				let n = v.balance == 0 ? 'null' : '',
					a = stock_id === v.id ? ' active' : '',
					cls = (n + a).length > 0 ? ' class="' + n + a + '"' : '';
				
				Size = resp.stock.fields_count;
				if (Size>3){Size=3;}
				
				html += '<tr'+ cls +'><td>' + v.create_date.replace(/(\d+:\d+:\d+$)/,'<u>$1</u>') + '</td><td>' + +(+v.balance).toFixed(5) + '</td>';
				for (let i=0;i<Size;i++){
					html += '<td>' + (Object.values(v.data)[i] || '') + '</td>';	
				}
				
				html += '</tr>';
			});

			// ### his
			if (stock_id && this.his[stock_id] != undefined && this.his[stock_id][field] != undefined) sum = this.his[stock_id][field]; 
			else if (!stock_id) sum = '';
			// ### end his

			document.body.insertAdjacentHTML('afterbegin', '\
				<div class="fon">\
					<div class="Popup" style="width: 450px; max-width: 100%">\
						<div class="title">'+LNG[797]+'<div class="pop-b"><b class="close"></b></div></div>\
						<div class="content" style="overflow: auto;">\
							<div>\
								<div class="row">\
									<div class="cell_1">'+LNG[786]+'</div>\
									<div class="cell_2">\
										<span class="measure" data-base="0" data-value="' + measure + '"><input type="number" name="balance" value="' + sum + '" min="0">\
											<i data-countable="' + countable + '"></i>\
										</span>\
									</div>\
								</div>\
							</div>\
							<div style="">\
								<table class="exc stock-position notnull">\
									<tr><th colspan='+(3+Size)+' style="position: relative;">'+LNG[785]+'<i class="n" style=""></i></th></tr>\
									<!-- <tr><th>Добавлен</th><th>' + measure.replace(/\./,'') + '</th><th></th></tr> -->\
									' + html + '\
								</table>\
							</div>\
						</div>\
						<div class="footer"><button data-ok="">'+LNG[46]+'</button><button data-close="">'+LNG[366]+'</button></div>\
					</div>\
				</div>');	
				this.box = document.querySelector('.fon');

				let dblclick = 0, dbtimer; //dbc
				this.box.onclick = function(e) {
					let active = this.box.querySelector('.active'),
						balance = this.box.querySelector('[name="balance"]'),
						index = a => (!!a && Array.from(a.parentNode.children).indexOf(a) - 1),
						i,
						value = (n = 0) => {
							((a = balance.value) && (balance.value = filter(a)));
							if (active && (i = index(active)) > -1) {
								if (resp.stock.result[i].balance > +balance.value) {
									if (n > 0) {
										balance.value = +balance.value + n;
										if (resp.stock.result[i].balance < +balance.value) balance.value = resp.stock.result[i].balance;
									}									
								} else balance.value = n > 0 ? 0 : resp.stock.result[i].balance;							
							} else balance.value = '';
						},
						close = () => (this.box.classList.add('close'), this.box.addEventListener('transitionend', () => this.box.remove()));
					balance.oninput = value;
					if ((a = e.target) && a.classList.contains('n')) {
						a.classList.toggle('on');
						a.closest('table').classList.toggle('notnull');
					}
					if (a = e.target.closest('tr:not(:first-child)')) {

						(clearTimeout(dbtimer), dbtimer = setTimeout(() => dblclick = 0, 250)); //dbc						
						if (++dblclick == 2 && active) (dblclick = 0, (active && active.classList.remove('active')), a.classList.add('active'), this.box.querySelector('[data-ok]').click()); //dbc
						else (a.classList.toggle('active') & (active && active.classList.remove('active')));
						
						balance.value = a.classList.contains('active') && (i = index(a)) > -1 ? (b = resp.stock.result[i].balance) > 0 ? b >= 1 ? 1 : b : 0 : '';

					}
					if ((a = e.target) && a.hasAttribute('data-countable')) value(1);
					if ((a = e.target) && a.hasAttribute('data-ok')) {
						let a, id, name, input;
						input = document.querySelector('[name="' + field_id + '"]');
						(balance.value > 0 && (i = index(active)) !== false && (id = resp.stock.result[i].id) && (name = resp.stock.result[i].data));

						// ### his
						let b = input.value.split('**');
						if (b[0] != id && b[1] != undefined && this.his[b[0]] != undefined) this.his[b[0]][field] = 0;
						if (id != undefined) this.his[id][field] = +balance.value || 0;
						// ### end his
						
						(input && (a = id !== undefined) & (input.value = a ? id + '**' + balance.value : '') & (input.disabled = a ? false : true));						
						(out.name && (out.name.textContent = name ? name[Object.keys(name)[0]] : ''));						
						(out.quantity && (out.quantity.textContent = a ? balance.value + ' ' + measure : '['+LNG[360]+']') && (out.quantity.dataset.id = a ? id : '') & ((b = out.quantity.closest('tr')) && (a ? b.classList.remove('null') : b.classList.add('null'))));
						close();
					}
					if (e.target.classList.contains('close') || e.target.hasAttribute('data-close')) close();
				}.bind(this)		
	}
}

function Confirm (text, func=()=>{}) {
	let div = document.createElement('div');
	div.classList.add('fon');
	div.innerHTML = '\
		<div class="fon">\
			<div class="confirm">\
				<div class="txt">'+(text?text:'')+'</div>\
				<button class="ok">Ok</button>\
				<button>Cancel</button>\
			</div>\
		</div>';
	document.body.append(div);
	div.addEventListener('click', (event) => {
		if(event.target.nodeName == 'BUTTON') {
			div.classList.add('close');
			div.addEventListener('transitionend', () => div.remove());
		}
		if(event.target.classList.contains('ok')) func();
	});
}

function animate({timing, draw, duration}) {					
	let start = performance.now();
	requestAnimationFrame(function animate(time) {
		let timeFraction = (time - start) / duration;
		if (timeFraction > 1) 
			timeFraction = 1;
		let progress = timing(timeFraction);
		draw(progress);
		if (timeFraction < 1) 
			requestAnimationFrame(animate);
	});
}

function Notifications(text, type) {
		
	let notifications = () => document.querySelector('.notifications');		
	if(!notifications()) document.body.insertAdjacentHTML('afterbegin', '<div class="notifications"></div>');		
	let ins = notifications().querySelector('.ins'),
		moving = () => Array.from(notifications().querySelectorAll('div:nth-child(n+2)'));
	if(ins) { // to force	
		ins.addEventListener('animationend', () => Notifications(text, type));
		ins.style.cssText = 'animation: fadeO ease .2s;';
		return;			
	}
	let	div = document.createElement('div'),
		cls = 'ins' + (type ? ' ' + type:'');
	div.classList.add(...cls.split(' '));
	div.innerHTML = text;
	notifications().prepend(div);			
	div.addEventListener('animationend', () => {
		div.classList.remove('ins');
		moving().forEach(v => v.style.cssText = '');
	});
	let h = div.offsetHeight + parseInt(getComputedStyle(div).marginTop);
	moving().forEach(v => v.style.cssText = 'transform: translateY('+h+'px);transition: all .4s;');
	setTimeout(() => {
		div.classList.add('hide');
		div.addEventListener('transitionend', () => div.remove());
	}, 4000);
}

document.addEventListener('DOMContentLoaded', () => {
	(function () {
		let zndx = 10;
		document.body.addEventListener('mousedown', function(event){
			if(event.target.classList.contains('move-push')) {	 
				let push = event.target,
					box = push.closest('.move'),
					fon = box.closest('.fon'),
					shiftX = event.clientX - box.getBoundingClientRect().left,
					shiftY = event.clientY - box.getBoundingClientRect().top,
					move = event => {
						box.style.position = 'absolute';
						box.style.left = event.pageX - shiftX + 'px';
						box.style.top = event.pageY - shiftY + 'px';
					};
					move(event);
				if (fon) {
					fon.classList.add('move-out');
					fon.addEventListener('transitionend', () => fon.classList.add('hide'));
				}
				box.style.zIndex = ++zndx;
				push.style.cursor = 'move';
				document.onmousemove = move;
				box.ondragstart = () => false;
				box.onmouseup = () => {
					if(!push.classList.contains('hand')) push.style.cursor = 'default';
					document.onmousemove = document.onmouseup = null;
				}
			 }
		});
	})();
});