<?php
include_once 'EasyPay.php';
include_once '../../config.php';

	if ($GLOBALS ["EnableEasyPayAM"] <> "True") {exit();}
	
	if ($GLOBALS ["UseEasypayAM_IPFilter"] == 'True') {
		$allowed_ips = $GLOBALS ['EasypayAM_allowed_ips'];
		if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
			echo("Запрос выполнен с неразрешенного IP адреса!");
			exit();
		}
	}


header('Content-Type: application/json');

//$mAddr = explode(":", $GLOBALS['mysql_adr']);
//$connection = new PDO("mysql:host=" . $mAddr[0] . ";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION]);
//$mikroBill = new Mikrobill($connection);
//$user = $mikroBill->findUserByLogin('');
//print_r($user);exit();



// Нужно 1 раз придумать и передать токен в EasyPay
$token = $GLOBALS['EasyPayAM_Token'];

$url = 'http' . ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') ? 's' : '') . '://';
$url = $url . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];

$routearr=explode('easypay.am/', $url);
$route = trim(strtolower ($routearr[1]),'/');
$query=file_get_contents('php://input');


WriteToLog($query,$route,'');

$params = json_decode($query, true);

try {
    $mAddr = explode(":", $GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=" . $mAddr[0] .";port=".$mAddr[1] . ";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION]);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    error($e->getMessage());
    exit;
}
$ep = new EasyPay($connection, $token);

switch ($route) {
    case 'check':
        $checkParams = new CheckParams($params);
        response($ep->check($checkParams));
        break;
    case 'payment':
        $payParams = new PaymentParams($params);
        response($ep->pay($payParams));
        break;
    default:
		if (strlen($route)>0){
			error("Действия $route не существует");
		} else {echo 'Hello my World!';}
}

function error($message)
{
    echo json_encode(['err' => $message], JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
}

/**
 * @param $response Response
 */
function response($response)
{
    echo json_encode($response, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
    exit;
}

function WriteToLog($query, $action, $msg){
	
	$fp = fopen("payin.txt", "a"); 
	fputs($fp, "\n\nDate = " . date("d.m.y H:i:s")."[Server IP - ".$_SERVER["REMOTE_ADDR"]."]\n");
	fputs($fp, "Action = $action\n");
	if (strlen($msg)>0){fputs($fp, "$msg\n");}
	fputs($fp,  print_r($query, true));
	
}
?>