<?php

if (isset($GLOBALS['HTTP_RAW_POST_DATA'])){
	$query = $GLOBALS['HTTP_RAW_POST_DATA'];
} else {
	$query = file_get_contents('php://input');	
}

if (strlen($query)==0){echo "Hello my World!";exit();}


header('Content-Type: text/xml');
include_once "../../config.php";

if ($GLOBALS ["UseGlobalMoney"] != 'True'){exit();}


if ($GLOBALS ["UseGlobalMoney_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['GlobalMoney_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		echo error(-1, "Запрос выполнен с неразрешенного адреса")->asXML();
		exit();
	}
}



try {
    $attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass']);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    echo error(-1, 'Невозможно установить соединение с БД')->asXML();
    exit;
}

$request = simplexml_load_string($query);

if (isset($request->Check)) {
	
	if ($request->Check->ServiceId <> $GLOBALS['GlobalMoney_ServiceID']){
		echo error(-1, "Unknown ServiceID")->asXML();
		exit();
	}
	
    $login = $request->Check->Account;
    check($login, $connection);
}

if (isset($request->Payment)) {
    $login = $request->Payment->Account;
    $orderId = $request->Payment->OrderId;
    $amount = $request->Payment->Amount;
    payment($login, $amount, $orderId, $connection);
}

if (isset($request->Confirm)) {
    $paymentId = $request->Confirm->PaymentId;
    confirm($paymentId, $connection);
}

if (isset($request->Cancel)) {
    $paymentId = $request->Cancel->PaymentId;
    cancel($paymentId, $connection);
}

if (isset($request->Balance)) {
    balance();
}

/**
 * @param string $login
 * @param PDO $connection
 */
function balance()
{
    $resp = response();
    $resp->addChild('Balance', '0');
    echo $resp->asXML();
    exit;
}



/**
 * @param string $login
 * @param PDO $connection
 */
function check($login, $connection)
{

    $query = "SELECT `FIO` AS 'name', `ballance` AS 'balance', `pinfo` FROM `stat` WHERE `user_name` LIKE ? or `contract` LIKE ?;";
    $statement = $connection->prepare($query);
    $statement->execute(array($login, $login));
    $user = $statement->fetch(PDO::FETCH_ASSOC);
	
    if ($user == false) {
        echo error(-1, 'Такого пользователя не существует')->asXML();
        exit;
    }
    $pinfo = explode('||', $user['pinfo']);
	$address = $pinfo[4];
	
    $resp = response();
    $resp->addChild('AccountInfo');
    $resp->AccountInfo->addChild('Name', $user['name']);
	$resp->AccountInfo->addChild('Address', $address);
    $resp->AccountInfo->addChild('Balance', $user['balance']);
    echo $resp->asXML();
    exit;
}

/**
 * @param string $login
 * @param string $amount
 * @param string $orderId
 * @param PDO $connection
 */
function payment($login, $amount, $orderId, $connection)
{
    $query = "SELECT `id` FROM `operations_globalmoney` WHERE `operation_id` = ?";
    $statement = $connection->prepare($query);
    $statement->execute(array($orderId));
    $payment = $statement->fetch(PDO::FETCH_ASSOC);
    if ($payment != false) {
        $resp = error(-1, 'Платеж уже был проведен');
        $resp->addChild('PaymentId');
        $resp->PaymentId = $payment['id'];
        echo $resp->asXML();
        exit;
    }
	
	if (((float)$GLOBALS ["GlobalMoney_MinPlat"]>$amount) || ((float)$GLOBALS ["GlobalMoney_MaxPlat"]<$amount)){
		echo error(-1, "The payment amount must be between " . $GLOBALS ["GlobalMoney_MinPlat"] . " and " . $GLOBALS ["GlobalMoney_MaxPlat"] . "!")->asXML();
		exit();
	}

	$query = "SELECT `user_name` FROM `stat` WHERE (`contract` LIKE ? or `user_name` LIKE ?)";
	$statement = $connection->prepare($query);
	$statement->execute(array($login,$login));
	$user = $statement->fetch(PDO::FETCH_ASSOC);
    $operationDate = date('Y-m-d H:i:s');
    $query = "INSERT INTO `operations_globalmoney` (`contract`,`sum`,`operation_id`,`date`, `confirmed`) VALUES (?,?,?,?,0)";
    $statement = $connection->prepare($query);
    $statement->execute(array($user['user_name'], $amount, $orderId, $operationDate));

    $resp = response();
    $resp->StatusDetail = "Order created";
    $resp->addChild('PaymentId');
    $resp->PaymentId = $connection->lastInsertId();
    echo $resp->asXML();
    exit;
}

/**
 * @param string $paymentId
 * @param PDO $connection
 */
function confirm($paymentId, $connection)
{
    $query = "SELECT `contract`, `sum`, `operation_id`, `date`, `confirmed` FROM `operations_globalmoney` WHERE `id` = ?";
    $statement = $connection->prepare($query);
    $statement->execute(array($paymentId));
    $payment = $statement->fetch(PDO::FETCH_ASSOC);

    if ($payment == false) {
        echo error(-1, 'Платеж не был найден')->asXML();
        exit;
    }
    if ($payment['confirmed'] == 1) {
        echo error(-1, 'Платеж уже был завершен')->asXML();
        exit;
    }

    $statement = $connection->prepare("SELECT `shortguid` FROM `stat` WHERE `contract` = ? or `user_name` = ?");
    $statement->execute(array($payment['contract'], $payment['contract']));
    $userId = $statement->fetch(PDO::FETCH_ASSOC);
    if ($userId == false) {
		$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,39,?);");
		$stm->execute([time(), $payment['sum'], $userId['shortguid']]);
		
        echo error(-1, "Не найден пользователь, невозможно пополнить баланс")->asXML();
        exit;
    }


    $dateTime = date("Y-m-d H:i:s");
    $uid = uniqid("", true) . uniqid("", true);
    $statement = $connection->prepare("INSERT INTO `addcash2` VALUES (?,?,0,'GLOBAL24',0, ?, '',?);");
    $statement->execute(array($userId['shortguid'], $payment['sum'], $uid, $dateTime));

    $statement = $connection->prepare("INSERT INTO `actionslog` VALUES (?,'ADD_MONEY',?,?,'','GLOBAL24')");
    $statement->execute(array($dateTime, $payment['contract'], $payment['sum']));

    //$statement = $connection->prepare("INSERT INTO `workparams` VALUES('REFRESH_DB','')");
	$statement = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
    $statement->execute();

    $statement = $connection->prepare("UPDATE `operations_globalmoney` SET `confirmed` = 1 WHERE `id` = ? ");
    $statement->execute(array($paymentId));

    $resp = response();
    $resp->StatusDetail = "Order Confirmed";
    $resp->addChild("OrderDate");
    $resp->OrderDate = $dateTime;
    echo $resp->asXML();
    exit;


}

/**
 * @param string $paymentId
 * @param PDO $connection
 */
function cancel($paymentId, $connection)
{
	
	$query = "SELECT `contract`, `sum`, `operation_id`, `date`, `confirmed` FROM `operations_globalmoney` WHERE `id` = ?";
    $statement = $connection->prepare($query);
    $statement->execute(array($paymentId));
    $payment = $statement->fetch(PDO::FETCH_ASSOC);

    if ($payment == false) {
        echo error(-1, 'Платеж не был найден')->asXML();
        exit;
    }
   
    $statement = $connection->prepare("SELECT `shortguid` FROM `stat` WHERE `contract` = ? or `user_name` = ?");
    $statement->execute(array($payment['contract'], $payment['contract']));
    $userId = $statement->fetch(PDO::FETCH_ASSOC);
    if ($userId == false) {
        echo error(-1, "Не найден пользователь, невозможно изменить баланс")->asXML();
        exit;
    }


    $dateTime = date("Y-m-d H:i:s");
    $uid = uniqid("", true) . uniqid("", true);
    $statement = $connection->prepare("INSERT INTO `addcash2` VALUES (?,?,0,'GLOBAL24',0, ?, 'Cancel operation',?);");
    $statement->execute(array($userId['shortguid'], -$payment['sum'], $uid, $dateTime));

    $statement = $connection->prepare("INSERT INTO `actionslog` VALUES (?,'ADD_MONEY',?,?,'','GLOBAL24')");
    $statement->execute(array($dateTime, $payment['contract'], $payment['sum']));

    //$statement = $connection->prepare("INSERT INTO `workparams` VALUES('REFRESH_DB','')");
	$statement = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
    $statement->execute();

   	
    $statement = $connection->prepare("DELETE FROM `operations_globalmoney` WHERE `id` = ?");
    $statement->execute(array($paymentId));

    $resp = response();
    $resp->StatusDetail = "Order canceled";
    $resp->addChild('CancelDate');
    $resp->CancelDate = date('Y-m-d H:i:s');

    echo $resp->asXML();
    exit;

}


function response()
{
    $datetime = date('Y-m-d\TH:i:s');
    $response = '<?xml version="1.0" encoding="UTF-8"?><Response><StatusCode>0</StatusCode><StatusDetail>OK</StatusDetail><DateTime>' . $datetime . '</DateTime><Sign></Sign></Response>';
    return new SimpleXMLElement($response);
}

function error($errorCode, $errorDetail)
{
    $datetime = date('Y-m-d\TH:i:s');
    $error = '<?xml version="1.0" encoding="UTF-8"?><Response>
    <StatusCode>' . $errorCode . '</StatusCode>
    <StatusDetail>' . $errorDetail . '</StatusDetail>
    <DateTime>' . $datetime . '</DateTime>
    <Sign></Sign>
</Response>';
    return new SimpleXMLElement($error);
}