<?php

if (!isset($_REQUEST['command'])) {echo "Hello my World!";exit();}

include_once "../../config.php";
header('Content-Type: text/xml');

$isLogEnable = true;
writeToLog($_SERVER['REQUEST_URI'], 'Запрос');


if ($GLOBALS ["UseiDRAM"] != 'True'){exit();}


if ($GLOBALS ["UseiDRAM_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['iDRAM_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		sendError(8, 'Запрос выполнен из неразрешенного адреса',-1);
	}
}

try {
	$attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC]);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    sendError(300, 'Невозможно установить соединение с БД',-1);
}


$command = $_REQUEST['command'];
switch ($command) {
    case 'check':
        check($_REQUEST['txn_id'], $_REQUEST['account'], $_REQUEST['sum']);
        break;
    case 'pay':
        pay($_REQUEST['txn_id'], $_REQUEST['txn_date'], $_REQUEST['account'], $_REQUEST['sum']);
        break;
    default:
        sendError(300, 'Неизвестная команда',-1);
}

function check($payId, $account, $sum)
{
    global $connection;
	$account=strtoupper($account);
    if ((float)$sum < 1) {
        sendError(241, 'Сумма слишком мала',-1);
    }
    $stm = $connection->prepare("SELECT `contract`, FIO AS `fio`, `ballance`, `otherinfo` FROM stat WHERE (UPPER(user_name) = ? or UPPER(contract) = ?)");
    $stm->execute([$account, $account]);
    $user = $stm->fetch();
    if ($user) {
		$bal=explode(' ',$user['ballance']);
		$bal=$bal[0];
		$bal=str_replace(',','.',$bal);
		
		$OtherInfo=explode('||',$user['otherinfo']);
		$recommended_payment=$OtherInfo[74];
		
        $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
        $response->addChild('osmp_txn_id', $payId);
        $response->addChild('result', 0);
        $fields = $response->addChild('fields');
        $fio = $fields->addChild('field1', $user['contract']);
        $fio->addAttribute('name', '№ договора');
        $fio->addAttribute('type', 'disp');
        $contract = $fields->addChild('field2', $user['fio']);
        $contract->addAttribute('name', 'Фио');
        $contract->addAttribute('type', 'disp');
        $fio = $fields->addChild('field3', $bal);
        $fio->addAttribute('name', 'Баланс');
        $fio->addAttribute('type', 'disp');
		$rec = $fields->addChild('field4', $recommended_payment);
        $rec->addAttribute('name', 'Рекомендованный платёж');
        $rec->addAttribute('type', 'disp');
        $response->addChild('comment', 'OK');
        writeToLog($response->asXML(), 'Ответ');
        echo $response->asXML();
    } else {
		$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,22,?);");
		$stm->execute([time(), $sum, $account]);
        sendError(5, 'Абонент не найден',$payId);
    }
}

function pay($payId, $date, $account, $sum)
{
    global $connection;
	$account=strtoupper($account);
    $query = "SELECT id FROM operations_idram WHERE operation_id = ?";
    $stm = $connection->prepare($query);
    $stm->execute([$payId]);
    $payment = $stm->fetch();
    if ($payment != false) {
        sendError(8, "Платёж уже был проведён",$payId);
    }

    $stm = $connection->prepare("SELECT shortguid FROM stat WHERE UPPER(user_name) = ? or UPPER(contract) = ?");
    $stm->execute([$account, $account]);
    $user = $stm->fetch();
    if ($user == false) {
        sendError(5, "Не найден идентификатор абонента",$payId);
    }

    $dateTime = date("Y-m-d H:i:s", strtotime($date));
    $uid = uniqid("", true) . uniqid("", true);
    $stm = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'IDRAM',0, ?, ?,?);");
    $stm->execute([$user['shortguid'], $sum, $uid, '', $dateTime]);

    $stm = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'','IDRAM')");
    $stm->execute([$dateTime, $account, $sum]);

    //$stm = $connection->prepare("INSERT INTO workparams VALUES('REFRESH_DB','')");
	$stm = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
    $stm->execute();

    $query = "INSERT INTO operations_idram (`contract`,`sum`,`operation_id`,`date`) VALUES (?,?,?,?)";
    $stm = $connection->prepare($query);
    $stm->execute([$account, $sum, $payId, $dateTime]);

    $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
    $response->addChild('osmp_txn_id', $payId);
    $response->addChild('prv_txn', $connection->lastInsertId());
    $response->addChild('sum', $sum);
    $response->addChild('result', '0');
    $response->addChild('comment', 'All is done');
    writeToLog($response->asXML(), 'Ответ');
    echo $response->asXML();
}

function sendError($code, $comment, $payId)
{
    $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
    $response->addChild('result', $code);
	if ($payId != -1){
		$response->addChild('osmp_txn_id', $payId);
	}
    $response->addChild('comment', $comment);
    echo $response->asXML();
    writeToLog($comment, 'Ответ');
    exit;
}

function writeToLog($message, $type)
{
    global $isLogEnable;
    if ($isLogEnable) {
        $string = '[' . date("Y:d:m H:i:s") . '] ' . $type . ': ' . str_replace(["\r\n", "\n", "\r"], '', $message) . PHP_EOL;
        file_put_contents('payin.txt', $string, FILE_APPEND | LOCK_EX);
    }
}
