<?php

if (!isset($_REQUEST['action'])) {echo "Hello my World!";exit();}

include_once "../../config.php";
header('Content-Type: text/xml');

$isLogEnable = true;
writeToLog($_SERVER['REQUEST_URI'], 'Запрос');


if ($GLOBALS ["UseKassa24"] != 'True'){exit();}


if ($GLOBALS ["UseKassa24_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['Kassa24_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		sendError(10, 'Запрос выполнен из неразрешенного адреса');
	}
}

try {
	$attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC]);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    sendError(11, 'Невозможно установить соединение с БД');
}


$command = $_REQUEST['action'];
switch ($command) {
    case 'check':
        check($_REQUEST['number']);
        break;
    case 'payment':
        pay($_REQUEST['receipt'], $_REQUEST['date'], $_REQUEST['number'], $_REQUEST['amount']);
        break;
    default:
        sendError(1, 'Неизвестная команда');
}

function check($account)
{
    global $connection;
	$account=strtoupper($account);
   
    $stm = $connection->prepare("SELECT contract, FIO AS `fio`, `ballance`, `otherinfo` FROM stat WHERE (UPPER(user_name) = ? or UPPER(contract) = ? or otherinfo LIKE ?)");
    $stm->execute([$account, $account, "%||$account||%"]);
    $user = $stm->fetch();
    if ($user) {
		$bal=explode(' ',$user['ballance']);
		$bal=$bal[0];
		$bal=str_replace(',','.',$bal);
		$otherinfo=explode('||',$user['otherinfo']);
		$rec_sum=$otherinfo[74];
        $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
        $response->addChild('code', 0);
		$response->addChild('client', $user['fio']);
		$response->addChild('amount', $rec_sum);
        $response->addChild('message', 'Абонент существует, возможен прием платежей');
        writeToLog($response->asXML(), 'Ответ');
        echo $response->asXML();
    } else {
        sendError(2, 'Абонент не найден');
    }
}

function pay($payId, $date, $account, $sum)
{
    global $connection;
	$account=strtoupper($account);
    $query = "SELECT id FROM operations_kassa24 WHERE operation_id = ?";
    $stm = $connection->prepare($query);
    $stm->execute([$payId]);
    $payment = $stm->fetch();
    if ($payment != false) {
        sendError(0, "Платёж уже был проведён");
    }

    $stm = $connection->prepare("SELECT shortguid FROM stat WHERE UPPER(user_name) = ? or UPPER(contract) = ? or otherinfo LIKE ?");
    $stm->execute([$account, $account, "%||$account||%"]);
    $user = $stm->fetch();
    if ($user == false) {
		$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,37,?);");
		$stm->execute([time(), $sum, $account]);
        sendError(2, "Не найден идентификатор абонента");
    }

    $dateTime = date("Y-m-d H:i:s", strtotime($date));
    $uid = uniqid("", true) . uniqid("", true);
    $stm = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'KASSA24',0, ?, ?,?);");
    $stm->execute([$user['shortguid'], $sum, $uid, '', $dateTime]);

    $stm = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'','KASSA24')");
    $stm->execute([$dateTime, $account, $sum]);

    //$stm = $connection->prepare("INSERT INTO workparams VALUES('REFRESH_DB','')");
	$stm = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
    $stm->execute();

    $query = "INSERT INTO operations_kassa24 (`contract`,`sum`,`operation_id`,`date`) VALUES (?,?,?,?)";
    $stm = $connection->prepare($query);
    $stm->execute([$account, $sum, $payId, $dateTime]);

    $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
    $response->addChild('code', 0);
    $response->addChild('authcode', $connection->lastInsertId());
    $response->addChild('message', 'Платеж принят');
    writeToLog($response->asXML(), 'Ответ');
    echo $response->asXML();
}

function sendError($code, $comment)
{
    $response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');

    $response->addChild('code', $code);	
    $response->addChild('message', $comment);
    echo $response->asXML();
    writeToLog($comment, 'Ответ');
    exit;
}

function writeToLog($message, $type)
{
    global $isLogEnable;
    if ($isLogEnable) {
        $string = '[' . date("Y:d:m H:i:s") . '] ' . $type . ': ' . str_replace(["\r\n", "\n", "\r"], '', $message) . PHP_EOL;
        file_put_contents('payin.txt', $string, FILE_APPEND | LOCK_EX);
    }
}
