<?php

if (!isset($_REQUEST['QueryType'])) {echo "Hello my World!";exit();}

include_once "../../config.php";
header('Content-Type: text/xml');

$isLogEnable = true;
writeToLog($_SERVER['REQUEST_URI'], 'Запрос');


if ($GLOBALS ["UsePayBerry"] != 'True'){exit();}


if ($GLOBALS ["UsePayBerry_IPFilter"] == 'True') {
	$allowed_ips = $GLOBALS ['PayBerry_allowed_ips'];
	if (array_search($_SERVER["REMOTE_ADDR"], $allowed_ips) === false) {
		SendError('Запрос выполнен c неразрешенного IP адреса',22);
	}
}

try {
	$attr = explode(':',$GLOBALS['mysql_adr']);
    $connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC]);
    $connection->exec("SET NAMES utf8");
} catch (Exception $e) {
    SendError('Невозможно установить соединение с БД',1);
	exit();
}


$QueryType = $_REQUEST['QueryType'];
switch ($QueryType) {
    case 'check':
        check($_REQUEST['Account'],$_REQUEST['TransactionId']);
        break;
    case 'pay':
        pay($_REQUEST['TransactionId'], $_REQUEST['Account'], $_REQUEST['Amount']);
        break;
    default:
        SendError('Неизвестная команда',299);
}

function check($account,$TransactionId)
{
    global $connection;
	$account=strtoupper($account);

    $stm = $connection->prepare("SELECT contract, FIO AS `fio`, `ballance`, `otherinfo` FROM stat WHERE (UPPER(user_name) = ? or UPPER(contract) = ?) ");
    $stm->execute([$account, $account]);
    $user = $stm->fetch();
	
	$response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><Response></Response>');
	$response->addChild('TransactionId', $TransactionId);
	
    if ($user) {	
		$response->addChild('ResultCode', 0);
		$fields = $response->addChild('Fields');
		$contract = $fields->addChild('field1', $user['contract']);
		$contract->addAttribute('name', '№ договора');
		$fio = $fields->addChild('field2', $user['fio']);
		$fio->addAttribute('name', 'ФИО');
		
		$bal=explode(' ',$user['ballance']);
		$bal=$bal[0];
		$bal=str_replace(',','.',$bal);
		
		$bal = $fields->addChild('field3', $bal);
		$bal->addAttribute('name', 'Баланс');
		
		$otherinfo = explode('||',$user['otherinfo']);
		
		$rec = $fields->addChild('field4', $otherinfo[74]);
		$rec->addAttribute('name', 'Рекомендованный платёж');
		
    } else {
		$response->addChild('ResultCode', 2);
    }
	echo $response->asXML();
}

function pay($payId, $account, $sum)
{
    global $connection;
	$account=strtoupper($account);
    $query = "SELECT id FROM operations_payberry WHERE operation_id = ?";
    $stm = $connection->prepare($query);
    $stm->execute([$payId]);
    $payment = $stm->fetch();
    if ($payment != false) {
		$response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
		$response->addChild('TransactionId', $payId);
		$response->addChild('ResultCode', 0);
		$response->addChild('TransactionExt', $payment['id']);
		$response->addChild('Amount', $sum);
		$response->addChild('Comment', 'OK');
		echo $response->asXML();
		exit();
    }

    $stm = $connection->prepare("SELECT shortguid FROM stat WHERE UPPER(user_name) = ? or UPPER(contract) = ?");
    $stm->execute([$account, $account]);
    $user = $stm->fetch();
    if ($user == false) {
		$stm = $connection->prepare("INSERT INTO `unknown_payments` (`moneytime`,`cash`,`pay_type`,`comment`) VALUES (?,?,33,?);");
		$stm->execute([time(), $sum, $account]);
		
		$response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
		$response->addChild('TransactionId', $payId);
		$response->addChild('ResultCode', 2);
		echo $response->asXML();
		exit();
    }

    $dateTime = date("Y-m-d H:i:s");
    $uid = uniqid("", true);
    $stm = $connection->prepare("INSERT INTO addcash2 VALUES (?,?,0,'PAYBERRY',0, ?, ?,?);");
    $stm->execute([$user['shortguid'], $sum, $uid, 'PAYBERRY', $dateTime]);

    $stm = $connection->prepare("INSERT INTO actionslog VALUES (?,'ADD_MONEY',?,?,'','PAYBERRY')");
    $stm->execute([$dateTime, $account, $sum]);

    //$stm = $connection->prepare("INSERT INTO workparams VALUES('REFRESH_DB','')");
	$stm = $connection->prepare("INSERT INTO `refresh_db` VALUES (1);");
    $stm->execute();

    $query = "INSERT INTO operations_payberry (`sum`,`operation_id`, `status`, `actiondate`) VALUES (?,?,?,?)";
    $stm = $connection->prepare($query);
    $stm->execute([$sum, $payId, 'OK', $dateTime]);

	$response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
	$response->addChild('TransactionId', $payId);
	$response->addChild('ResultCode', 0);
	$response->addChild('TransactionExt', $connection->lastInsertId());
	$response->addChild('Amount', $sum);
	$response->addChild('Comment', 'OK');
	echo $response->asXML();

}

function SendError($message, $type){
	$response = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><response></response>');
	$response->addChild('ResultCode', $type);
	$response->addChild('Comment', $message);
	echo $response->asXML();
	exit();
}


function writeToLog($message, $type)
{
    global $isLogEnable;
    if ($isLogEnable) {
        $string = '[' . date("Y:d:m H:i:s") . '] ' . $type . ': ' . str_replace(["\r\n", "\n", "\r"], '', $message) . PHP_EOL;
        file_put_contents('payin.txt', $string, FILE_APPEND | LOCK_EX);
    }
}
