﻿<?php

#include_once 'config.php';

define('STATUS_PENDING', 0);
define('STATUS_PAID', 1);
define('STATUS_ERROR', 2);


class Hmac {
    static function create($data, $key, $algo = 'sha256') {
        if (!in_array($algo, hash_algos()))
            return false;
        $data = (array) $data;
        array_walk_recursive($data, function(&$v){
            $v = strval($v);
        });
        self::_sort($data);
        if (version_compare(PHP_VERSION, '5.4.0', '<')) {
            $data = preg_replace_callback('/((\\\u[01-9a-fA-F]{4})+)/', function ($matches) {
                return json_decode('"'.$matches[1].'"');
            }, json_encode($data));
        }
        else {
            $data = json_encode($data, JSON_UNESCAPED_UNICODE);
        }
        return hash_hmac($algo, $data, $key);
    }

    static function verify($data, $key, $sign, $algo = 'sha256') {
        $_sign = self::create($data, $key, $algo);
        return ($_sign && (strtolower($_sign) == strtolower($sign)));
    }

    static private function _sort(&$data) {
        ksort($data, SORT_REGULAR);
        foreach ($data as &$arr)
            is_array($arr) && self::_sort($arr);
    }
}



function Process_Prodamus($userName, $amount, $userId, $contract, $phone, $linktoform, $secret_key){

	$strings=$GLOBALS['strings'];
	
	try {
		$attr = explode(':',$GLOBALS['mysql_adr']);
		$connection = new PDO("mysql:host=".$attr[0].";port=".$attr[1].";dbname=" . $GLOBALS['mysql_db'], $GLOBALS['mysql_user'], $GLOBALS['mysql_pass'], [PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC]);
		$connection->exec("SET NAMES utf8");
	} catch (Exception $e) {
		file_put_contents('errors.txt', date('Y-m-d H:i:s').' '.$e->getMessage().PHP_EOL, FILE_APPEND);
		exit;
	}
	$query = "INSERT INTO `operations_prodamus` (`shortguid`,`user_name`,`amount`,`data_init`, `prodamus_id`) VALUES (?,?,?,?,?)";
	$stm = $connection->prepare($query);
	$result = $stm->execute([$userId, $userName, $amount, date('Y-m-d H:i:s'), 0]);

	if( $result )
	{
		
		$orderId = (int) $connection->lastInsertId();
		
		$url = 'http' . ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') ? 's' : '') . '://';
		$url = $url . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
		
		$uri=explode("prodamus.php", $url);
		
		if (strlen($GLOBALS['PaySite'])>8) {
			$result_url = trim($GLOBALS['PaySite'],'/') . "/pay2.php?action=1";
			$fail_url = trim($GLOBALS['PaySite'],'/') . "/pay2.php?action=3";
			$server_url = trim($GLOBALS['PaySite'],'/') . "/payin/prodamus/payin.php";
		} else {
			
			$result_url = $uri[0] . "pay2.php?action=1";
			$fail_url = $uri[0] . "pay2.php?action=3";
			$server_url = $uri[0] . "payin/prodamus/payin.php";
		}
				
		
		// 531 - Пополнение лицевого счета по договору
		// 532 - дополнительные данные
		
		$payment = [
			'order_id' => $orderId,
			'customer_phone' => $phone,
			'products' => [
				[
					'name' => $strings[531] . ' ' .$contract,
					'price' => $amount,
					'quantity' => '1',
				],
			],
			'customer_extra' => $strings[532],
			'do' => 'pay',
			'urlReturn' => $result_url,
			'urlSuccess' => $server_url,
			'urlFail' => $fail_url,
		];

		$payment['signature'] = Hmac::create($payment, $secret_key);
		header("Location: " . sprintf('%s?%s', $linktoform, http_build_query($payment)));
		die();
	}
	else
	{
		file_put_contents('/payin/prodamus/errors.txt', date('Y-m-d H:i:s').' '.$stm->errorCode().PHP_EOL, FILE_APPEND);
		die();
	}
	
}